package com.google.gwt.sample.stockwatcher.server;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

import com.google.gwt.sample.stockwatcher.client.api.StockPriceService;

public class StockPriceServiceFilter implements Filter {

	private StockPriceService sps;
	public static final String SPS_ATTRIBUTE_NAME="stockPriceServiceAttributeName";
	
	public StockPriceServiceFilter(StockPriceService service) {
		this.sps = service;
	}
	
	public void init(FilterConfig config) throws ServletException {
		config.getServletContext().setAttribute(SPS_ATTRIBUTE_NAME, sps);
	}

	public void destroy() {
	}

	public void doFilter(ServletRequest request, ServletResponse response,
			FilterChain chain) throws IOException, ServletException {
		chain.doFilter(request, response);
	}
}
